#ifndef SHMACMASTER_H_
#define SHMACMASTER_H_

#include <systemc.h>
#include "shmac_interfaces.h"
#include "SHMACElement.h"

// submodule includes and forward class declarations
// TODO

class SHMACMaster: public sc_module
{
public:
	sc_port<SHMACMemoryInterface> outboundMemoryPort;
	sc_port<SHMACMemoryInterface> inboundMemoryPort;

	SHMACMaster(sc_module_name instanceName, SHMACElement * parent = NULL);
	~SHMACMaster();

	SHMACElement* getParent() const
	{
		return m_parent;
	}

	virtual void setParent(SHMACElement* parent)
	{
		m_parent = parent;
	}


protected:
	SHMACElement * m_parent;
};

#endif /* SHMACMASTER_H_ */
