/*
 * SHMACMemToRTLAdapter.h
 *
 *  Created on: Jun 4, 2013
 *      Author: maltanar
 */

#ifndef SHMACMEMTORTLADAPTER_H_
#define SHMACMEMTORTLADAPTER_H_

#include <systemc.h>
#include "shmac_types.h"
#include "shmac_interfaces.h"


class SHMACMemToRTLAdapter : public SHMACMemoryInterface, public sc_module
{
public:
	SHMACMemToRTLAdapter(sc_module_name name);
	virtual ~SHMACMemToRTLAdapter();

	// data outputs
	sc_out<bool> tx_req;
	sc_out<shmacsim::packet> tx_data;
	sc_in<bool> tx_ack;

	// implemented from SHMACMemoryInterface
	// receive a SHMAC mem message and pass it onto the RTL IF
	void receiveMessage(shmacsim::packet message);
};

#endif /* SHMACMEMTORTLADAPTER_H_ */
