/*
 * SHMACRTLToMemAdapter.h
 *
 *  Created on: Jun 4, 2013
 *      Author: maltanar
 */

#ifndef SHMACRTLTOMEMADAPTER_H_
#define SHMACRTLTOMEMADAPTER_H_

#include <systemc.h>
#include "shmac_types.h"
#include "shmac_interfaces.h"

class SHMACRTLToMemAdapter: public sc_module
{
	SC_HAS_PROCESS(SHMACRTLToMemAdapter);

public:
	SHMACRTLToMemAdapter(sc_module_name name);
	virtual ~SHMACRTLToMemAdapter();

	sc_signal<bool> rx_req;
	sc_signal<shmacsim::packet> rx_data;
	sc_signal<bool> rx_ack;

	sc_port<SHMACMemoryInterface> txPort;

protected:
	// SC_THREAD to dispatch incoming RTL-level requests
	// to the SHMACMemoryInterface port
	void sendRequests();
};

#endif /* SHMACRTLTOMEMADAPTER_H_ */
