/*
 * SHMACPrintSlave.cpp
 *
 *  Created on: 18 Mar 2013
 *      Author: Yaman Umuroglu
 */

#include "SHMACPrintSlave.h"

SHMACPrintSlave::SHMACPrintSlave(sc_module_name name, SHMACElement* parent) :
		SHMACSlave(name, 4, parent, false)
{
}

void SHMACPrintSlave::memorySetWord(SHMAC_ADDR address, SHMAC_WORD data)
{
	// TODO need to separate message sources (multiple tiles)
	// otherwise we get intermingled printing
	std::cout << (char) data;
}

// read on print slave always returns 0
SHMAC_WORD SHMACPrintSlave::memoryGetWord(SHMAC_ADDR address)
{
	return 0;
}
