/*
 * SHMACSlavePort.h
 *
 *  Created on: Jul 3, 2013
 *      Author: maltanar
 */

#ifndef SHMACSLAVEPORT_H_
#define SHMACSLAVEPORT_H_

#include "SHMACSlave.h"

class SHMACSlavePort : public SHMACMemoryInterface
{
public:
	SHMACSlavePort();
	virtual ~SHMACSlavePort();

	void attachToSlave(SHMACSlave * slave, int portIndex);
	void receiveMessage(shmacsim::packet message);

protected:
	bool m_attached;

	// variables for slave access - will be set upon attachment
	sc_mutex * m_memLock;
	sc_event * m_pendingRequest, * m_requestServed;
	shmacsim::packet * m_packetBuffer;
};

#endif /* SHMACSLAVEPORT_H_ */
