/*
 * shmac_interfaces.h
 *
 * the SystemC interfaces for SHMACsim components
 *
 *  Created on: 26 Feb 2013
 *      Author: Yaman Umuroglu
 */

#ifndef SHMAC_INTERFACES_H_
#define SHMAC_INTERFACES_H_

#include <systemc.h>
#include "shmac_types.h"

class SHMACMemoryInterface : public sc_interface {
public:
	virtual void receiveMessage(shmacsim::packet message) = 0;
};


#endif /* SHMAC_INTERFACES_H_ */
