#ifndef SHMACROUTERCROSSBAR_H_
#define SHMACROUTERCROSSBAR_H_

#include <systemc.h>
#include "shmac_simutils.h"
#include "shmac_types.h"

class SHMACRouterCrossbar: public sc_module
{
public:
	SC_HAS_PROCESS(SHMACRouterCrossbar);

	sc_in<bool> arb_grant[SHMAC_DIRECTION_COUNT][SHMAC_DIRECTION_COUNT];

	sc_in<shmacsim::packet> rx_data[SHMAC_DIRECTION_COUNT];
	sc_out<bool> rx_ack[SHMAC_DIRECTION_COUNT];

	sc_out<shmacsim::packet> tx_data[SHMAC_DIRECTION_COUNT];
	sc_in<bool> tx_ack[SHMAC_DIRECTION_COUNT];

	SHMACRouterCrossbar(sc_module_name name);

	void switching();
};

#endif /* SHMACROUTERCROSSBAR_H_ */
