/*
 * SHMACClockSlave.cpp
 *
 *  Created on: Jun 19, 2013
 *      Author: maltanar
 */

#include "SHMACClockSlave.h"
#include "shmac_simutils.h"

SHMACClockSlave::SHMACClockSlave(sc_module_name name, SHMACElement * parent) :
		SHMACSlave(name, 12, parent, false)
{


}

SHMACClockSlave::~SHMACClockSlave()
{

}

void SHMACClockSlave::memorySetWord(SHMAC_ADDR address, SHMAC_WORD data)
{
	// not implemented
	// TODO implement control register
}

SHMAC_WORD SHMACClockSlave::memoryGetWord(SHMAC_ADDR address)
{
	SHMAC_WORD retval = (SHMAC_WORD)(sc_time_stamp() / shmacsim::getClockCycles(1));

	return shmacsim::convertHostToTargetEndian_32bit(retval);
}
