/*
 * SHMACClockSlave.h
 *
 *  Created on: Jun 19, 2013
 *      Author: maltanar
 */

#ifndef SHMACCLOCKSLAVE_H_
#define SHMACCLOCKSLAVE_H_

#include "SHMACSlave.h"
#include <systemc.h>

class SHMACClockSlave: public SHMACSlave
{
public:
	SHMACClockSlave(sc_module_name name, SHMACElement * parent = NULL);
	virtual ~SHMACClockSlave();

protected:
	// virtual methods for memory access - reimplemented for jump slave
	virtual void memorySetWord(SHMAC_ADDR address, SHMAC_WORD data);
	virtual SHMAC_WORD memoryGetWord(SHMAC_ADDR address);
};

#endif /* SHMACCLOCKSLAVE_H_ */
